//**************Henry S Fortuna July-2001*********

#ifndef _DEFINES_H_
#define _DEFINES_H_

#define OTLEN   (4)			// Resolution of ordering table.
#define SCNW    (320)		// Screen x-resolution.
#define SCNH    (240)		// Screen y-resolution.
#define kBYTE	(1024)

#define GAME_INTRO		0
#define GAME_MENU			1
#define GAME_PLAYING	2
#define GAME_PAUSED		3
#define GAME_LEVELUP	4
#define GAME_OUTTRO		5

#define LEVELDX				256
#define LEVELDY				64
#define TILESCALE			16
#define NUMTILES			64
#define NOPROJ				5

#define DEBUG				0

#define GRAVITY				1
#define LOADSTAGES			12	
#define NOENEMY				32

#define TAILX	(0)
#define TAILY	(12)

#define	NORMAL			0
#define	MOONJUMP		1
#define	FIRESUIT		2
#define	ACCORDIAN		3
#define	TRUMPET			4
#define	INVINCIBLE		5
#define	INFOBOX			6
#define	RESTART			7
#define	ENDLEVEL		8

//------------------------------------------
/*
// define fix notation------------
typedef int fix;
#define Fix(n) (n<<12)
#define UnFix(n) (n>>12)
#define FixMult(x,y) ( (x >> 6) * (y >> 6) )
#define FixDiv(x,y) ( (x/y) << 12)
*/
#endif