#include "base.h"
#include "graphics.h"
#include "draw.h"
#include <stdio.h>
#include <strings.h>




int DrawFrame(){
	extern whatPlayer;
	extern S_player aapj;
	extern S_enemy badguy[NOENEMY+1];
	extern GsSPRITE sp_BG_0;
	extern GsSPRITE sp_collectable;
	extern GsSPRITE sp_font;
	extern GsSPRITE sp_projectile;
	extern drawlayer lyr_bg0;
	extern drawlayer lyr_0_main;
	extern int level;
	
	extern int bg01[LEVELDY/4][LEVELDX/4];
	extern tile bg01tilelist[16];
	extern S_collectable DiscoLoveFlower[10];
	extern S_collectable vinyl[200];
	extern S_collectable otherCollect[32];
	int i, facing;
	extern char displaystring[256];

	
	StartFrame();				
		
		//draw any messages ------------------------------------------
		sp_font.r = 128;	sp_font.g = 128;	sp_font.b = 128;	
		drawText(64,32,displaystring, 24);		
	
		
		
		DrawDiscoLoveFlowers();							//draw disco love collection point
		
			
		drawText(16, 8,"`score`", 7);		
		printint(16, 16, aapj.score, 1);								//draw score		
		drawText(112, 8,"`vinyl`", 7);				
		printint(112, 16, aapj.records, 1);								//draw vinyl			
		drawText(218, 8,"`lives`", 7);		
		printint(218, 16, aapj.lives, 1);								//draw lives
		
		
		if (aapj.actor.jumping == 1){// ----------------------------------------- draw if JUMPING
			aapj.basev = 64;
			if(aapj.actor.object.yvel < 0){					//going up
				if (aapj.actor.object.yvel < (aapj.actor.maxjump/2))
					aapj.actor.object.entity.sprite->u = 0;
				else
					aapj.actor.object.entity.sprite->u = 16;
			}
			else{											//going down
				if (aapj.actor.object.yvel < (aapj.actor.maxjump/-2))
					aapj.actor.object.entity.sprite->u = 32;
				else
					aapj.actor.object.entity.sprite->u = 48;
			}
			
			if (aapj.actor.object.xvel < 0){
				facing = 1;			
				aapj.actor.object.entity.sprite->v = aapj.basev+32;
			}
			else{
				facing = 0;	
				aapj.actor.object.entity.sprite->v = aapj.basev;				
			}	
			aapj.actor.object.entity.sprite->x = aapj.actor.object.entity.x+lyr_0_main.layerx + aapj.actor.object.entity.sprite->mx;
			aapj.actor.object.entity.sprite->y = aapj.actor.object.entity.y+lyr_0_main.layery + aapj.actor.object.entity.sprite->my;
			GsSortSprite(aapj.actor.object.entity.sprite, Gfx.pOT, 0);
			
		}
		else{// ---------------------------------------------------------------- draw if NOT jumping
			if(aapj.actor.object.xvel == 0)
				aapj.actor.object.entity.sprite->v = 128;
			else{
				aapj.basev = 0;					
				if (aapj.actor.object.xvel < 0){
					facing = 1;			
					aapj.actor.object.entity.sprite->v = aapj.basev+32;
				}
				else{
					facing = 0;	
					aapj.actor.object.entity.sprite->v = aapj.basev;				
				}	
			}
			drawentity(&aapj.actor.object.entity, 0);					//drawplayer	
		}	
				if(whatPlayer) DrawTail();
		if( (aapj.basepower == FIRESUIT) || (aapj.timepower == INVINCIBLE) ){
			sp_projectile.x = aapj.actor.object.entity.x+6+lyr_0_main.layerx+rand()%4;
			sp_projectile.y = aapj.actor.object.entity.y+14+lyr_0_main.layery+rand()%4;			
			
			if(facing == 1) sp_projectile.scalex*=-1;				
			sp_projectile.u = (rand()%4)*32;		
			sp_projectile.scalex = 6144+rand()%1024;
			
			if(aapj.basepower == FIRESUIT) {//----------------------fire
			sp_projectile.v = 0;
			}		
			else {//------------------------------------------------invincible
			sp_projectile.v = 32;	
			sp_projectile.scalex = (aapj.powertime*10)+rand()%1024;
			}							
			
			
			sp_projectile.scaley = sp_projectile.scalex;
			sp_projectile.w = 32;		
			sp_projectile.h = 32;	
			GsSortSprite(&sp_projectile, Gfx.pOT, 0);			
		}
		
		for (i=0;i<NOENEMY;i++){
		badguy[i].actor.object.entity.sprite->v = badguy[i].type*16;
		
			if(badguy[i].actor.health == 0){
				badguy[i].actor.object.entity.sprite->scaley = 1024;	//set scale squashed			
				if( (badguy[i].actor.object.entity.x > (aapj.actor.object.entity.x-240)) && (badguy[i].actor.object.entity.x < (aapj.actor.object.entity.x+240)) )
					drawentity(&badguy[i].actor.object.entity, facing);		//draw badguy				
				}				
			else{
				if (badguy[i].actor.object.xvel < 0)					//set direction
					facing = 1;
				else
					facing = 0;
				badguy[i].actor.object.entity.sprite->scaley = 4096;	//set scale normal	
				if( (badguy[i].actor.object.entity.x > (aapj.actor.object.entity.x-240)) && (badguy[i].actor.object.entity.x < (aapj.actor.object.entity.x+240)) )
					drawentity(&badguy[i].actor.object.entity, facing);		//draw badguy
			}
		}
			
		//#########################################################################################################
		//#########################################################################################################
		// AAAAAAAAAAAAAAAAAAAARRRRRRRRRGGGGGGGGGGHHHHHHHHHHHHHH
		// for whatever reason this doesnt work properly if you use drawentity()
		for( i = 0; i<199; i++){	
		
			if(vinyl[i].collected == 0){
			if( (vinyl[i].entity.x > (aapj.actor.object.entity.x-240)) && (vinyl[i].entity.x < (aapj.actor.object.entity.x+240)) ){

					vinyl[i].entity.frame+=1;		
					sp_collectable.x = vinyl[i].entity.x+lyr_0_main.layerx;
					sp_collectable.y = vinyl[i].entity.y+lyr_0_main.layery;
					sp_collectable.u = ((vinyl[i].entity.frame>>3)%4)*16;
					sp_collectable.v = 0;
			
					GsSortSprite(&sp_collectable, Gfx.pOT, 0);
				}
			}
		}
	
		for( i = 0; i<10; i++){
			
			if(DiscoLoveFlower[i].collected == 0){
				if( (DiscoLoveFlower[i].entity.x > (aapj.actor.object.entity.x-240)) && (DiscoLoveFlower[i].entity.x < (aapj.actor.object.entity.x+240)) ){
				DiscoLoveFlower[i].entity.frame+=2;
			
				sp_collectable.x = DiscoLoveFlower[i].entity.x+lyr_0_main.layerx;
				sp_collectable.y = DiscoLoveFlower[i].entity.y+lyr_0_main.layery;
				sp_collectable.u = ((DiscoLoveFlower[i].entity.frame>>3)%4)*16;;
				sp_collectable.v = 16;
				GsSortSprite(&sp_collectable, Gfx.pOT, 0);
				}			
			}
		}
			
		for( i = 0; i<32; i++){
			if( (otherCollect[i].entity.x > (aapj.actor.object.entity.x-240)) && (otherCollect[i].entity.x < (aapj.actor.object.entity.x+240)) ){
			
				if(otherCollect[i].collected == 0){
					otherCollect[i].entity.frame++;
				
					sp_collectable.x = otherCollect[i].entity.x+lyr_0_main.layerx;
					sp_collectable.y = otherCollect[i].entity.y+lyr_0_main.layery;
					sp_collectable.u = ((otherCollect[i].entity.frame>>3)%4)*16;;
					sp_collectable.v = otherCollect[i].type*16;
					GsSortSprite(&sp_collectable, Gfx.pOT, 0);
				}
			}
		}
		

		//#########################################################################################################
		//#########################################################################################################

		
		
		
		
		drawmain();														//draw level
		DrawBGLayer(&sp_BG_0, &lyr_bg0, bg01tilelist);					//draw background
		
	EndFrame();
	return 0;
}

// =======================================================================================
// draw main level (layer 0 ==============================================================

void drawmain(void){
	int tx,ty;
	int startx, endx, starty, endy;
	extern GsSPRITE sp_level;
	extern drawlayer lyr_0_main;
	extern int level_1[LEVELDY][LEVELDX];
	extern tile tilelist[144];
	
	//DrawOverlay();

	startx = -(lyr_0_main.layerx / TILESCALE);
	endx = startx +21;
	starty = -(lyr_0_main.layery / TILESCALE);
	endy = starty +16;
	colourlayer(&lyr_0_main, 2);
	for(tx=startx;tx<endx;tx++){			
		for(ty=starty;ty<endy;ty++){
			if(level_1[ty][tx] != 0){
				sp_level.x = (tx<<4)+lyr_0_main.layerx;
				sp_level.y = (ty<<4)+lyr_0_main.layery;		
				sp_level.r = lyr_0_main.dr;		
				sp_level.g = lyr_0_main.dg;		
				sp_level.b = lyr_0_main.db;
				sp_level.u = tilelist[level_1[ty][tx]].u;
				sp_level.v = tilelist[level_1[ty][tx]].v;
				GsSortSprite(&sp_level, Gfx.pOT, 0);	
			}	
		}	
	}
}






void DrawBGLayer(GsSPRITE *MySprite, drawlayer *MyLayer, tile MyTilelist[]){
	int tx,ty;
	int startx, endx, starty, endy;
	extern drawlayer lyr_bg0;
	extern drawlayer lyr_0_main;
	
	extern int bg01[LEVELDY/4][LEVELDX/4];
	
	MyLayer->layerx = lyr_0_main.layerx/2;
	MyLayer->layery = lyr_0_main.layery/2;

	startx = -(MyLayer->layerx / (TILESCALE*2));
	endx = startx +11;
	starty = -(MyLayer->layery / (TILESCALE*2));
	endy = starty +8;
		
	colourlayer(&lyr_bg0, 2);
	for(tx=startx;tx<endx;tx++){			
		for(ty=starty;ty<endy;ty++){
			//if(bg01[ty][tx] != 0){
				MySprite->x = (tx<<5)+MyLayer->layerx;
				MySprite->y = (ty<<5)+MyLayer->layery;		
				MySprite->r = lyr_bg0.dr;		
				MySprite->g = lyr_bg0.dg;		
				MySprite->b = lyr_bg0.db;
				MySprite->u = MyTilelist[bg01[ty][tx]].u;
				MySprite->v = MyTilelist[bg01[ty][tx]].v;
				GsSortSprite(MySprite, Gfx.pOT, 0);	
			//}	
		}	
	}
}






















