#include "draw_over.h"


void printint(int x, int y, int num, int allnums){
	int working, offset = 8, i, decimal[7];
	extern GsSPRITE sp_overlay;
	
	if (num < 0) return;			//if number is <0, dont do the rest

	sp_overlay.w 		= 8;		//set sprite up for drawing numbers
	sp_overlay.h 		= 12;
	sp_overlay.x 		= x;
	sp_overlay.y 		= y;
	sp_overlay.u 		= 0;
	sp_overlay.v 		= 0;	
		
	working = num;					//set working to the number
									
									//work out the seperate parts of the number, units, tens, hundreds etc
	decimal[0] =  working / 1000000;
	decimal[1] = (working -= (decimal[0]*1000000)) / 100000;
	decimal[2] = (working -= (decimal[1]*100000)) / 10000;
	decimal[3] = (working -= (decimal[2]*10000)) / 1000;	
	decimal[4] = (working -= (decimal[3]*1000)) / 100;	
	decimal[5] = (working -= (decimal[4]*100)) / 10;
	decimal[6] = (working -= (decimal[5]*10));
	

	for(i = 0; i<7; i++){			//draw the number on the screen
		sp_overlay.x = x + i*offset;		
		sp_overlay.u = decimal[i]*offset;		
		GsSortSprite(&sp_overlay, Gfx.pOT, 0);	
	}
}


void drawText(int x, int y, char *string, int linelength){
int i, line = 0, length;
char num;
char tc = 'k';
extern GsSPRITE sp_font;
length = strlen(string);

	for (i = 0; i<length; i++){
		num = string[i]-32;
		sp_font.x = x+(i%linelength)*8;
		sp_font.y = y+(i/linelength)*8;
		sp_font.u = (num%8)*8;
		sp_font.v = (num/8)*8;
		GsSortSprite(&sp_font, Gfx.pOT, 0);	
	}

}