#include "collision.h"

// =======================================================================================
// check what direction a collision is occuring in [bounding box] ========================
int bbox_collision_dir(S_entity *a, S_entity *b){

		if ( (a->y <= (b->y + b->sprite->h) ) && ( (a->y + a->sprite->h) > (b->y + b->sprite->h)))	//intersects bottom
			return 1;
		if ((a->y < b->y) && ((a->y + a->sprite->h) >= b->y))						//intersects top
			return 4;
		if ((a->x < b->x) && ((a->x + a->sprite->w) >= b->x ))						//intersects left
			return 2;
		if ((a->x <= (b->x + b->sprite->w)) && ((a->x + a->sprite->w) > (b->x + b->sprite->w)))		//intersects right
			return 3;

	return 0;
}


// =======================================================================================
// collision between two entities [bounding box] =========================================
int bbox_collision(S_entity *a, S_entity *b){

if(!(((a->x + a->sprite->w) <= b->x) 	|| 
	(a->x >= (b->x + b->sprite->w)) 	|| 
	((a->y + a->sprite->h) <= b->y)  	|| 
	(a->y >= (b->y + b->sprite->h)) ))	
	return 1;

else 	
	return 0;

}

