#ifndef _INIT_H_
#define _INIT_H_


// ============================== things
extern S_player aapj;
extern S_enemy badguy[NOENEMY+1];
extern S_collectable DiscoLoveFlower[10];
extern S_collectable otherCollect[32];
extern S_collectable Vinyl[200];

extern int editmode, selection;
extern int dooverlay;
extern int x1, y1, x2, y2, select;

//=============================== sprites
extern GsSPRITE sp_level;
extern GsSPRITE sp_player;
extern GsSPRITE sp_enemy;
extern GsSPRITE sp_collectable;
extern GsSPRITE sp_overlay;
extern GsSPRITE sp_BG_0;
extern GsSPRITE sp_copyover;

extern GsSPRITE sp_font;

extern char displaystring[256];

// ============================== layers
extern drawlayer lyr_0_main;
extern drawlayer lyr_bg0;
extern drawlayer lyr_sun;


// ============================== tilemaps
extern int level_1[LEVELDY][LEVELDX];
extern int bg01[LEVELDY/4][LEVELDX/4];

extern int CopyBuffer[64][64];

extern tile tilelist[144];
extern tile bg01tilelist[16];


// ============================== collision maps
extern int collisionmap[15][TILESCALE];



// ============================== functions
void InitialiseHeap(void);
void buildmaplookup(void);
void InitLayers(void);
void initplayer(S_player *theplayer);
void initcollisionmaps(void);
void initenemy(S_enemy *badguy, int x, int y, int type);


// ============================== function pointer
extern int (* DoState)(void);

#endif