#ifndef _INIT_H_
#define _INIT_H_

#include "sound.h"

// ============================== things
extern S_player aapj;
extern S_enemy badguy[NOENEMY+1];
extern S_collectable DiscoLoveFlower[10];
extern S_collectable otherCollect[32];
extern S_collectable Vinyl[200];

extern int whatPlayer, level, sfxvol, musicvol;
//=============================== sprites
extern GsSPRITE sp_level;
extern GsSPRITE sp_sun;
extern GsSPRITE sp_player;
extern GsSPRITE sp_enemy;
extern GsSPRITE sp_collectable;
extern GsSPRITE sp_sun;
extern GsSPRITE sp_titlebar;
extern GsSPRITE sp_overlay;
extern GsSPRITE sp_BG_0;

extern GsSPRITE sp_tail;
extern GsSPRITE sp_font;
extern GsSPRITE sp_projectile;
extern GsSPRITE sp_title1;
extern GsSPRITE sp_title2;

extern char displaystring[256];

// ============================== layers
extern drawlayer lyr_0_main;
extern drawlayer lyr_bg0;
extern drawlayer lyr_sun;


// ============================== tilemaps
extern int level_1[LEVELDY][LEVELDX];
extern int bg01[LEVELDY/4][LEVELDX/4];

extern tile tilelist[144];
extern tile bg01tilelist[16];


// ============================== collision maps
extern int collisionmap[23][TILESCALE];



// ============================== functions
void InitialiseHeap(void);
void buildmaplookup(void);
void InitLayers(void);
void initplayer(S_player *theplayer);
void initcollisionmaps(void);
void initenemy(S_enemy *badguy, int x, int y, int type);


// ============================== function pointer
extern int (* DoState)(void);
extern int GameOver(void);
extern int LevelStart(void);
extern int GameEnd(void);

extern voice_data 	playerjump, 
					playerdie,
					powerdown,
					life_up,
					swish,
					vlife,
					vinyl1,
					vinyl2,
					vinyl3
			;
#endif