/*#include <libps.h>
#include "pad.h"
#include "sound.h"
         
#define OTLEN   (1)
#define SCNW    (320)
#define SCNH    (240)
//#define MAIN_VOL (127)
//#define SEQ_VOL  (127) 

//Globals *******************************************
static GsOT ot[2];
static GsOT_TAG ottags[2][1<<OTLEN];
static int buf;


//Functions *****************************************
// Initialise the graphics **************************
void initGfx(void)
{
SetVideoMode(MODE_PAL);                     
GsInitGraph(SCNW,SCNH,4,0,0);
GsDefDispBuff(0,0,0,SCNH);
ot[0].length = OTLEN;                      
ot[0].org = ottags[0];
ot[1].length = OTLEN;                      
ot[1].org = ottags[1];
}//initGfx

//Load fonts into VRAM ******************************
void loadfont(void)
{
FntLoad(960,256);                           
FntOpen(0,0,SCNW,SCNH,0,512);
}//loadfont

//prepare frame *************************************
void StartFrame(void)
{
buf = GsGetActiveBuff();                   
GsClearOt(0,0,&ot[buf]);   
}//StartFrame

//do actual drawing *********************************
void EndFrame(void)
{
DrawSync(0);                      
VSync(0);
GsSwapDispBuff();
GsSortClear(0,0,0,&ot[buf]);             
GsDrawOt(&ot[buf]);
}//EndFrame   



void main(void) 
{
  short vab_id;					      // vab id number 0-15
  short seq_id;					      // seq id number 0-32 
  static unsigned char vh[70*1024];
  static unsigned char vb[400*1024];
  static unsigned char vs[20*1024];

  printf("the address of vh is 0x%x\n", vh);
  printf("the address of vb is 0x%x\n", vb);  
  printf("the address of vs is 0x%x\n", vs);   
	
  initGfx();
  loadfont();
  initPads();
  
  MWbload("data/genmidi.vh", vh);
  MWbload("data/genmidi.vb", vb);
  MWbload("data/gogo.seq", vs);

  vab_id = InitSoundSys(vh,vb);
  seq_id = InitMusic((unsigned long*)vs, vab_id);

  SetupReverb();                                 // set reverb 
   
  PlayMusic(seq_id);

  while (1) 
  {
    StartFrame();                  

    FntPrint("  Press Start to exit\n");
    FntPrint("  Press Triangle to pause music\n");
    FntPrint("  Press Cross to replay music\n");

    if (padState(0) & PadStart)break;
    if (padState(0) & PADtriangle)SsSeqPause(seq_id);
    if (padState(0) & PADcross)SsSeqReplay(seq_id);
      
    FntFlush(-1);
    EndFrame();
   }

  StopSoundSys(vab_id);
  StopMusic(seq_id); 
  ResetGraph(1);
}
*/

