

#include "base.h" 
//#include "extramaths.h"
#include "thegame.h"
#include "collision.h"
#include "sound.h"


void playerDies(){
extern int (* DoState)(void);
extern int GameOver(void);
extern int LevelStart(void);
extern S_player aapj;
extern drawlayer lyr_0_main, lyr_bg0;
extern voice_data playerdie;

	PlaySFX(&playerdie);
	//fade out -------------------------------------------------------------------------------------------------------------------
	lyr_0_main.r = lyr_0_main.g = lyr_0_main.b = lyr_bg0.r = lyr_bg0.g = lyr_bg0.b = 0;
	do{
		aapj.actor.object.entity.sprite->r = aapj.actor.object.entity.sprite->g = aapj.actor.object.entity.sprite->b = lyr_0_main.dr;
		DrawFrame();
	}while(lyr_0_main.dr>2);
	
	//reset everything -------------------------------------------------------------------------------------------------------------------
	aapj.actor.object.entity.x = aapj.actor.startpos.x;	
	aapj.actor.object.entity.y = aapj.actor.startpos.y;	
	aapj.lives-=1;	
	
	scrolllayer(&aapj.actor);
	lyr_0_main.r = lyr_0_main.g = lyr_0_main.b = lyr_bg0.r = lyr_bg0.g = lyr_bg0.b = 128;	
			 		
	if(aapj.lives == 0)	
		DoState = &GameOver;
	else	
		DoState = &LevelStart;	
	//fade in -------------------------------------------------------------------------------------------------------------------
	do{
		aapj.actor.object.entity.sprite->r = aapj.actor.object.entity.sprite->g = aapj.actor.object.entity.sprite->b = lyr_0_main.dr;
		DrawFrame();
	}while(lyr_0_main.dr<126);
	
	aapj.actor.object.yvel = 0;
}


// =======================================================================================
// main bit that calls everything ========================================================

void GameLogic(){
extern int whatPlayer, level;
extern S_player aapj;
extern S_enemy badguy[NOENEMY+1];	
extern S_collectable DiscoLoveFlower[10];
extern S_collectable vinyl[10];
extern S_collectable otherCollect[32];
extern char displaystring[256];
extern int (* DoState)(void);
extern int GameEnd(void);

extern voice_data 	powerdown,		life_up,		vlife,
					vinyl1,			vinyl2,			vinyl3;
int i;	
	//---------------------------------------------------------------------------------------------------------
	aapj.actor.lastpos.x = aapj.actor.object.entity.x;
	aapj.actor.lastpos.y = aapj.actor.object.entity.y;
	
	aapj.powertime--;
	if(aapj.powertime < 0 ){
		if(aapj.timepower != NORMAL)
			PlaySFX(&powerdown);
		aapj.timepower = NORMAL;
		ApplyPower(aapj.basepower);	
	}
	aapj.infotime--;
	if(aapj.infotime < 0 ){
		strcpy(displaystring, "");
	}
	
	
	moveactor(&aapj.actor , 1);									// move player
		if(aapj.actor.object.entity.y > 16*LEVELDY-48){			// if player falls off of level
		aapj.actor.object.entity.x = 146;						// reset for debugging
		aapj.actor.object.entity.y = 192;
		aapj.actor.object.xvel = 0;
		aapj.actor.object.yvel = 0;		
	}
	if(whatPlayer){												// do flowing tail if yasmin character
		if((aapj.actor.object.entity.x != aapj.actor.lastpos.x) || (aapj.actor.object.entity.y != aapj.actor.lastpos.y)){
		   
		   	aapj.old_at++;
			aapj.oldpos[aapj.old_at%10].x = aapj.actor.object.entity.x + TAILX;
			aapj.oldpos[aapj.old_at%10].y = aapj.actor.object.entity.y + TAILY;

		}

	}
	CollideWithWalls(&aapj.actor);								// position player outside walls
	CollideWithGround(&aapj.actor);								// position player on ground
	
	
	//---------------------------------------------------------------------------------------------------------
	if(aapj.actor.object.entity.y > 40*16){	
		playerDies();
	}
	for (i=0;i<NOENEMY;i++){									// badguys-
		if(badguy[i].actor.health != 0){						// do if badguy is alive
			AImove(&badguy[i]);									// think about where to move
			moveactor(&badguy[i].actor ,1);						// move		
			CollideWithGround(&badguy[i].actor);				// position on ground
			if( (badguy[i].actor.object.entity.y > 16*LEVELDY-48) || (badguy[i].actor.object.entity.x < 0))	// if badguy falls off level, kill badguy
				badguy[i].actor.health = 0;			
			if (bbox_collision(&aapj.actor.object.entity, &badguy[i].actor.object.entity)){	//collide bad guy with player
				if(aapj.actor.object.yvel > 0){			//if pj is falling, then he wins
		 			badguy[i].actor.health = 0;
		 			badguy[i].actor.object.xvel =0;
		 			badguy[i].actor.object.entity.y+=12;
		 			aapj.score+=badguy[i].score;
					aapj.actor.jumping = 0;
		 		}
		 		else{									// badguy wins
		 			if(aapj.basepower == FIRESUIT){		// or not! if fire pj then saved!!
		 				badguy[i].actor.health = 0;
		 				badguy[i].actor.object.xvel =0;
		 				badguy[i].actor.object.entity.y=-16;
		 				aapj.score+=badguy[i].score;
						aapj.basepower = NORMAL;
						ApplyPower(aapj.basepower);
						break;
		 			}
		 			if(aapj.timepower == INVINCIBLE){		// or not! if invincible pj safe!!
		 				badguy[i].actor.health = 0;
		 				badguy[i].actor.object.xvel =0;
		 				badguy[i].actor.object.entity.y=-16;
		 				aapj.score+=badguy[i].score;		 			
		 			}

		 			else{			 			
				 		playerDies();
			 		}		 			
		 		}
			}
		}		
	}
	
	for (i=0;i<10;i++){											// disco love flowers
		if(DiscoLoveFlower[i].collected == 0 ){
			if (bbox_collision(&DiscoLoveFlower[i].entity,&aapj.actor.object.entity)){
				DiscoLoveFlower[i].collected = 1;
		 		aapj.score+=DiscoLoveFlower[i].score;
				aapj.discolove++; 
				aapj.showmydiscolove=240; 	 	
				PlaySFX(&vinyl3);	
				if (aapj.discolove == 10){
					aapj.discolove=0; 
					aapj.lives+=3;	 			
					PlaySFX(&life_up);
				}
		 	}
		}
	}
	
	for (i=0;i<199;i++){											// vinyl
		if(vinyl[i].collected == 0 ){
			if (bbox_collision(&vinyl[i].entity,&aapj.actor.object.entity)){
			vinyl[i].collected = 1;
		 	aapj.score+=vinyl[i].score;
		 	aapj.records++;	 	
			PlaySFX(&vinyl1);	
			 	if(aapj.records == 100){
		 			aapj.lives++;
		 			aapj.records = 0;		 			
					PlaySFX(&life_up);	
		 		}		 	
		 	}
		}
	}
	
	for (i=0;i<32;i++){											// otherCollects
		if(otherCollect[i].collected == 0 ){
			if (bbox_collision(&otherCollect[i].entity,&aapj.actor.object.entity)){
			//otherCollect[i].collected = 1;	 
		 	aapj.score+=otherCollect[i].score;
				switch(otherCollect[i].type){
					case 2: // moon jump
						aapj.basepower = MOONJUMP;	
						PlaySFX(&vinyl2);	
						break;
					case 3:// fire suit
						aapj.basepower = FIRESUIT;
						PlaySFX(&vinyl2);	
						break;
					case 4:// invincible
						aapj.timepower = INVINCIBLE;
						PlaySFX(&vinyl2);	
						ApplyPower(INVINCIBLE);
						break;
					case 5:// trumpet
						aapj.basepower = TRUMPET;
						PlaySFX(&vinyl2);	
						break;
					case 6:// funkaccordian
						aapj.basepower = ACCORDIAN;
						PlaySFX(&vinyl2);	
						break;
					case 7://infobox
						aapj.infotime = 200;
			 			otherCollect[i].collected = 0;
			 			otherCollect[i].score = 0;
			 			switch(i){
			 			case 0:
							strcpy(displaystring, "````````````````````````` This is a help point,`` when you run in to   `` it you will be given `` useful hints such as `` this one.            `````````````````````````");
							break;
						case 1:
							strcpy(displaystring, "````````````````````````` Here comes an enemy! `` Jump on its head to  `` get rid of it!       `````````````````````````");
							break;
			 			case 2:
							strcpy(displaystring, "````````````````````````` This is some vinyl,  `` once you have        `` collected 100 of     `` these discs, you get `` an extra life!       `````````````````````````");
							break;
			 			case 3:
							strcpy(displaystring, "````````````````````````` This is a Disco Love `` Flower, collecting   `` just 10 of these     `` will earn you 3      `` extra lives, but     `` they are often       `` hidden or in hard to `` reach places         `````````````````````````");
							break;
			 			case 4:
							strcpy(displaystring, "````````````````````````` This is a            ``    RESTART POINT     `` if you die after     `` this your next life  `` will begin here!     `````````````````````````");
							break;
			 			case 5:
							strcpy(displaystring, "````````````````````````` This gives you       ``  MOON JUMPING POWER  `` when you are glowing `` white you can jump   `` much higher than     `` ever before!         `````````````````````````");
							break;		
						case 6:
							strcpy(displaystring, "````````````````````````` This gives you       ``    INVINCIBILITY     `` When surrounded by   ``  the ball of light   `` you cannot come to   `` to any harm from      `` enemies             `````````````````````````");
							break;			 			
	 			
						default:
							strcpy(displaystring, "");
							break;
			 			}
						break;
					case 8:// restart		
						PlaySFX(&vinyl2);					
						aapj.actor.startpos.x = otherCollect[i].entity.x;					
						aapj.actor.startpos.y = otherCollect[i].entity.y;
						break;
					case 9:// end
						level++;
						PlaySFX(&vlife);
						switch(level){
						case 2:
							loadlevel("levels/level2/");							
							break;
						case 3:
							loadlevel("levels/level3/");
							break;
						case 4:
							loadlevel("levels/level4/");
							break;
						default:
							DoState = &GameEnd;	
							return ;
						}
						return;
				}
				
				ApplyPower(aapj.basepower);
		 	}
		 	
		}
	}

	//---------------------------------------------------------------------------------------------------------	
	scrolllayer(&aapj.actor);									// scroll screen to show player
	
}


// =======================================================================================
// scroll the main layer(level) ==========================================================
void scrolllayer(S_actor *scrollwith){
extern drawlayer lyr_0_main;

	lyr_0_main.layerx = -1*(scrollwith->object.entity.x - ((SCNW/5)*2));
	lyr_0_main.layery = -1*(scrollwith->object.entity.y - (SCNW/2)); 

	if (lyr_0_main.layerx > -16) { lyr_0_main.layerx = -16;}
	if (lyr_0_main.layery > 0) { lyr_0_main.layery = 0;}

}


// =======================================================================================
// move an actor based on x and y velocities =============================================
void moveactor(S_actor *moveme, int gravityflag){
	
	moveme->object.oldx = moveme->object.entity.x;
	moveme->object.oldy = moveme->object.entity.y;
	
	moveme->object.entity.x += moveme->object.xvel;
	moveme->object.entity.y += moveme->object.yvel;
	
	if (moveme->object.xvel > moveme->object.maxspeed) 		{ moveme->object.xvel = moveme->object.maxspeed; }
	if (moveme->object.xvel < (-1*moveme->object.maxspeed)) 	{ moveme->object.xvel = -1*moveme->object.maxspeed; }
	
	if (gravityflag != 0){
		moveme->object.yvel += GRAVITY;
	}

}


// =======================================================================================
// Think about where ai should move to====================================================
AImove(S_enemy *enemy){
extern drawlayer lyr_0_main;

	int tile_nextonleft, tile_nextonright, ontile_x, ontile_y; 
	extern int level_1[LEVELDY][LEVELDX];
	extern tile tilelist[64];

	enemy->actor.object.entity.frame += 1;
			
	if (enemy->aware != 0){
		ontile_x = (enemy->actor.object.entity.x+enemy->actor.object.hillx) / TILESCALE;
		ontile_y = (enemy->actor.object.entity.y+enemy->actor.object.hilly) / TILESCALE;	
	
		tile_nextonleft 	= tilelist[level_1[ontile_y+1][ontile_x-1]].collide;		//onleft
		tile_nextonright 	= tilelist[level_1[ontile_y+1][ontile_x+1]].collide;		//onright
		
/*
		FntPrint(Gfx.FntID,"~c000\n\nnextleft: %d  ",tile_nextonleft);
		FntPrint(Gfx.FntID,"is one?: %d  ",tile_nextonleft==1 );
		FntPrint(Gfx.FntID,"isnt one?: %d",tile_nextonleft!=1 );
*/
		
		if (enemy->actor.jumping == 0){
			if ( (enemy->actor.object.xvel < 0) && ( (tile_nextonleft == 0) || (tile_nextonleft == 99))){ //moving left
				switch(enemy->aware){
				case 1:									//-------------------- turn
					enemy->actor.object.xvel *= -1;
					break;
				case 2:									//-------------------- jump
					enemy->actor.object.yvel = enemy->actor.maxjump;
					enemy->actor.jumping = 1;
					break;
				}
			}
			
			if ( (enemy->actor.object.xvel > 0) && ( (tile_nextonright== 0) || (tile_nextonright== 99) )){ //moving right
				switch(enemy->aware){
				case 1:
					enemy->actor.object.xvel *= -1;
					break;
				case 2:
					enemy->actor.object.yvel = enemy->actor.maxjump;
					enemy->actor.jumping = 1;
					break;
				}
			}
		}
	}


}

void loadlevel(char *thislevel){
	extern S_player aapj;
	extern int level_1[LEVELDY][LEVELDX]; 	
	extern S_enemy badguy[NOENEMY+1];
	extern S_collectable DiscoLoveFlower[10];
	extern S_collectable vinyl[200];
	extern S_collectable otherCollect[32];

	unsigned char levelrw[LEVELDY+10][LEVELDX];
	int result, tx, ty;
	char toload[50];
	//loadprogress(1, 6, "   loading    ");
		
	StartFrame();	
	drawText(180,220,"` Loading `", 11);	
	EndFrame();			
	StartFrame();	
	drawText(180,220,"` Loading `", 11);	
	EndFrame();			
	StartFrame();	
	drawText(180,220,"` Loading `", 11);	
	EndFrame();			
	StartFrame();	
	drawText(180,220,"` Loading `", 11);	
	EndFrame();		
	
		
	buildmaplookup();

		for(tx=0;tx<LEVELDX;tx++){	
			for(ty=0;ty<LEVELDY;ty++){				
				level_1[ty][tx] = levelrw[ty][tx] = 0;
			}
		}			


		strcpy(toload, "");
		strcat(toload, thislevel);
		strcat(toload, "layout.lvl");
		result = MWbload(toload, levelrw);		//load tiles			
		for(tx=0;tx<LEVELDX;tx++){	
			for(ty=0;ty<LEVELDY;ty++){				
				level_1[ty][tx] = levelrw[ty][tx];	//convert tiles to ints
				if (level_1[ty][tx] == 11){			//set start position
					aapj.actor.startpos.x = aapj.actor.object.entity.x = tx<<4;					
					aapj.actor.startpos.y = aapj.actor.object.entity.y = ty<<4;
				}
			}			
		}	
//		loadprogress(2, 6, "    vinyl   ");

		// +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+- get vinyl from file
		strcpy(toload, "");
		strcat(toload, thislevel);
		strcat(toload, "vinyl.pos");
		result = MWbload(toload, levelrw);
		for(tx=0;tx<398;tx+=2){
			vinyl[tx/2].entity.x = levelrw[0][tx]*16;
			vinyl[tx/2].entity.y = levelrw[0][tx+1]*16;
			vinyl[tx/2].collected = 0;
		}
//		loadprogress(3, 6, "   flower   ");

		// +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+- get flowers from file
		strcpy(toload, "");
		strcat(toload, thislevel);
		strcat(toload, "discolove.pos");
		result = MWbload(toload, levelrw);
		for(tx=0;tx<20;tx+=2){
			DiscoLoveFlower[tx/2].entity.x = levelrw[0][tx]*16;
			DiscoLoveFlower[tx/2].entity.y = levelrw[0][tx+1]*16;
			DiscoLoveFlower[tx/2].collected = 0;
		}
		aapj.discolove = 0;
//		loadprogress(4, 6, "  collect   ");
		// +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+- get collects from file
		strcpy(toload, "");
		strcat(toload, thislevel);
		strcat(toload, "collect.pos");
		result = MWbload(toload, levelrw);
		for(tx=0;tx<128;tx+=4){
			otherCollect[tx/4].entity.x 	= levelrw[0][tx]*16;
			otherCollect[tx/4].entity.y 	= levelrw[0][tx+1]*16;
			otherCollect[tx/4].type 		= levelrw[0][tx+2];
			otherCollect[tx/4].score 		= levelrw[0][tx+3];
			otherCollect[tx/4].collected = 0;
		}
	//	loadprogress(5, 6, "   enemies  ");
		// +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+- get enemies from file
		
		strcpy(toload, "");
		strcat(toload, thislevel);
		strcat(toload, "enemy.pos");
		result = MWbload(toload, levelrw);
		for(tx=0;tx<124;tx+=4){
			badguy[tx/4].actor.startpos.x 		= badguy[tx/5].actor.object.entity.x = levelrw[0][tx]*16 ;
			badguy[tx/4].actor.startpos.y 		= badguy[tx/5].actor.object.entity.y = levelrw[0][tx+1]*16;
			badguy[tx/4].type 					= levelrw[0][tx+2];
			badguy[tx/4].actor.object.yvel 		= levelrw[0][tx+3];
			if(badguy[tx/4].actor.object.yvel == 255) badguy[tx/4].actor.object.yvel = -1;
			if(badguy[tx/4].actor.startpos.y >0){
				badguy[tx/4].actor.health = 1;
			}
		}
		
}

void endLevel(){
	extern int level;
	char loadit[16];
	char lnum;
	level=2;
	
	lnum = level+48;
	strcpy(loadit, "levels/level");
	strcat(loadit, lnum);
	strcat(loadit, "/");
	
	FntPrint(Gfx.FntID,"\n\n\n\n\n\n\n%d", level);
	
	switch(level){
		case 1:
			loadlevel("levels/level1/");
			break;
		case 2:
			loadlevel("levels/level2/");
			break;
		case 3:
			loadlevel("levels/level3/");
			break;
		case 4:
			loadlevel("levels/level4/");
			break;
	}
	loadlevel(loadit);

}

void ApplyPower(int power){
extern S_player aapj;
extern char displaystring[256];

	switch(power){
		case NORMAL:		//normal
			aapj.actor.maxjump = 	-6;
			aapj.actor.object.entity.sprite->r = 128;
			aapj.actor.object.entity.sprite->g = 128;
			aapj.actor.object.entity.sprite->b = 128;

			break;
		case MOONJUMP:		//jump
			aapj.actor.maxjump = 	-16;
			aapj.actor.object.entity.sprite->r = 255;
			aapj.actor.object.entity.sprite->g = 255;
			aapj.actor.object.entity.sprite->b = 255;
		
			break;
		case FIRESUIT:		//fire
			aapj.actor.maxjump = 	-6;
			aapj.actor.object.entity.sprite->r = 255;
			aapj.actor.object.entity.sprite->g = 64;
			aapj.actor.object.entity.sprite->b = 64;
		
			break;
		case ACCORDIAN:		//accordian
			aapj.actor.maxjump = 	-6;
			aapj.actor.object.entity.sprite->r = 128;
			aapj.actor.object.entity.sprite->g = 128;
			aapj.actor.object.entity.sprite->b = 128;
		
			break;
		case TRUMPET:		//trumpet
			aapj.actor.maxjump = 	-6;
			aapj.actor.object.entity.sprite->r = 128;
			aapj.actor.object.entity.sprite->g = 128;
			aapj.actor.object.entity.sprite->b = 128;
		
			break;
		case INVINCIBLE:	//invincible		
			aapj.actor.object.entity.sprite->r = 255;
			aapj.actor.object.entity.sprite->g = 255;
			aapj.actor.object.entity.sprite->b = 128;
			aapj.powertime = 500;
			
			break;
		case INFOBOX:		//info
			aapj.actor.object.entity.sprite->r = 128;
			aapj.actor.object.entity.sprite->g = 128;
			aapj.actor.object.entity.sprite->b = 128;
			aapj.powertime = 200;		
			break;		
		case RESTART:		//info
			break;		
		case ENDLEVEL:		//info
			aapj.actor.object.entity.sprite->r = 128;
			aapj.actor.object.entity.sprite->g = 128;
			aapj.actor.object.entity.sprite->b = 128;
			aapj.powertime = 200;		
			break;
	}


}