

#include "base.h" 
//#include "extramaths.h"
#include "thegame.h"
#include "collision.h"

void EditCopySingle(int thistile){
	extern int CopyBuffer[64][64];
	int tx, ty;

	for(tx = 0; tx < 64 ;tx ++){
		for(ty = 0; ty < 64 ;ty ++){
			CopyBuffer[tx][ty] = -1;	
		}
	}
	CopyBuffer[0][0] = thistile;	
	

}

void EditCopyBlock(){
	extern S_player aapj;
	extern int CopyBuffer[64][64];
	extern int x1, y1, x2, y2, select;
	extern int level_1[LEVELDY][LEVELDX];
	int startx, starty, endx, endy, tx, ty, onx, ony;
	startx = x1;	starty = y1;
	endx = x2;		endy = y2;

	if(x2 < x1){
		startx = x2;
		endx = x1;
	}
	if(y2 < y1){
		starty = y2;
		endy = y1;
	}


	for(tx = 0; tx < 64 ;tx += 16){
		for(ty = 0; ty < 64 ;ty += 16){
			CopyBuffer[tx][ty] =-1;
		}
	}

	for(tx = startx; tx <= endx ;tx += 16){
		for(ty = starty; ty <= endy ;ty += 16){
			onx = (tx-startx)/16;
			ony = (ty-starty)/16;
			
			 CopyBuffer[ony][onx] = level_1[ty/16][tx/16];
		}
	}	


}

void EditPaste(){
	extern GsSPRITE sp_player;
	extern S_player aapj;
	extern drawlayer lyr_0_main;
	extern int CopyBuffer[64][64];
	extern int x1, y1, x2, y2, select;
	extern int level_1[LEVELDY][LEVELDX];
	int startx, starty, endx, endy, tx, ty, onx, ony, atx, aty;

	startx = x1;	starty = y1;
	endx = x2;		endy = y2;

	if(x2 < x1){
		startx = x2;
		endx = x1;
	}
	if(y2 < y1){
		starty = y2;
		endy = y1;
	}
	
	if(select != 1){//pasting 1 tile
		
		if (CopyBuffer[0][1] != -1){	//-------------------- paste block
			atx = (aapj.actor.object.entity.x)/16;
			aty = (aapj.actor.object.entity.y)/16;

			for(tx = 0; tx <= 64 ;tx += 16){
				for(ty = 0; ty <= 64 ;ty += 16){
					onx = tx/16;
					ony = ty/16;
					if(CopyBuffer[ony][onx] > 0)
						level_1[ony+aty][onx+atx] = CopyBuffer[ony][onx];
				}
			}	
		}
		
		else{//----------------------------------------------- paste 1 tile
			onx = (aapj.actor.object.entity.x)/16;
			ony = (aapj.actor.object.entity.y)/16;
			level_1[ony][onx] = CopyBuffer[0][0];	
		}
	}
	
	if(select == 1){
		if (CopyBuffer[0][1] == -1){//----------------------- fill many tiles with one
			for(tx = startx; tx <= endx ;tx += 16){
				for(ty = starty; ty <= endy ;ty += 16){
					onx = tx/16;
					ony = ty/16;
					level_1[ony][onx] = CopyBuffer[0][0];	
				}
			}
		}
	}
}
// =======================================================================================
// main bit that calls everything ========================================================

void GameLogic(){
extern int whatPlayer;
extern S_player aapj;
	
//	moveactor(&aapj.actor , 1);									// move player
	scrolllayer(&aapj.actor);									// scroll screen to show player
	
}


// =======================================================================================
// scroll the main layer(level) ==========================================================
void scrolllayer(S_actor *scrollwith){
extern drawlayer lyr_0_main;
//drawlayer scrollme = lyr_0_main;
	
	if 		((scrollwith->object.entity.x + lyr_0_main.layerx) > 200)
			{ lyr_0_main.layerx -= 8; }
	else if ((scrollwith->object.entity.x + lyr_0_main.layerx) <150) 
			{ lyr_0_main.layerx += 8; }

	if 		((scrollwith->object.entity.y + lyr_0_main.layery) > 150) 
			{ lyr_0_main.layery -= 8; }	
	else if ((scrollwith->object.entity.y + lyr_0_main.layery) < 50) 	
			{ lyr_0_main.layery += 8; }

	if (lyr_0_main.layerx > 0) { lyr_0_main.layerx = 0;}
	if (lyr_0_main.layery > 0) { lyr_0_main.layery = 0;}

}


// =======================================================================================
// move an actor based on x and y velocities =============================================
void moveactor(S_actor *moveme, int gravityflag){
	
	moveme->object.oldx = moveme->object.entity.x;
	moveme->object.oldy = moveme->object.entity.y;
	
	moveme->object.entity.x += moveme->object.xvel;
	moveme->object.entity.y += moveme->object.yvel;
	
	if (moveme->object.xvel > moveme->object.maxspeed) 		{ moveme->object.xvel = moveme->object.maxspeed; }
	if (moveme->object.xvel < (-1*moveme->object.maxspeed)) 	{ moveme->object.xvel = -1*moveme->object.maxspeed; }
	
	if (gravityflag != 0){
		moveme->object.yvel += GRAVITY;
	}

}
